package com.sjkj.base_lib.net.request;

import android.content.Context;

import com.sjkj.base_lib.entity.Params;
import com.sjkj.base_lib.entity.ResponseBean;
import com.sjkj.base_lib.net.RetrofitFactory;
import com.sjkj.base_lib.net.data.exception.BusinessException;
import com.sjkj.base_lib.net.domain.interactor.UseCase;
import com.sjkj.base_lib.tree.bean.AddressTreeListBean;
import com.sjkj.base_lib.utils.AppTools;

import java.util.List;

import rx.Observable;
import rx.functions.Func1;

/**
 * 获取所在地列表
 */
public class AddressTreeListRequest extends UseCase {
    private Context context;
    private RetrofitBaseService service;

    private Params params;

    public Params getParams() {
        return params;
    }

    public void setParams(Params params) {
        this.params = params;
    }

    public AddressTreeListRequest(Context context) {
        this.context = context;
        service = RetrofitFactory.getRetrofit(AppTools.getBaseUrl()).create(RetrofitBaseService.class);
    }

    @Override
    protected Observable buildUseCaseObservable() {
        return service.GetDictTree(params).flatMap(new Func1<ResponseBean<List<AddressTreeListBean>>, Observable<List<AddressTreeListBean>>>() {
            @Override
            public Observable<List<AddressTreeListBean>> call(ResponseBean<List<AddressTreeListBean>> responseBean) {
                if (!ResponseBean.CODE_SUCCESS.
                        equals(responseBean.getCode())) {
                    return Observable.error(new BusinessException(responseBean.getMsg()));
                }
                return Observable.just(responseBean.getData());
            }
        });
    }
}
